#include <stdio.h>

#include "RecordStore.h"

int RecordStore::getEid(char * record, int rec_size){

    int temp;
    memcpy((char *)(&temp), record+rec_size-sizeof(int), sizeof(int));
    return temp;
}

int RecordStore::getFid(char * record, int rec_size){

    int temp;
    memcpy((char *)(&temp), record+rec_size-2*sizeof(int), sizeof(int));
    return temp;

}

bool RecordStore::scanCheck(char *  record, int rec_size,
                            char *  eName,  char * eContent){
     // skip the last two fid and eid
     rec_size -= 8;

     // initialized it.
     unsigned short level;
     memcpy(&level, record+rec_size-sizeof(level), sizeof(level));
     
     unsigned short id;
     
     if(!idTable->getID(eName,id)) return false;

     int index = (id % idBucket) % level;
     int offset =0;

     unsigned short temp1, temp2;
     memcpy(&temp1, record+rec_size-6,sizeof(temp1));
     for (int i=0;i<index;i++){
         memcpy(&temp2,record+temp1-(level-i)*2,sizeof(temp2));
	 offset += temp2;
     }
     memcpy(&temp2,record+temp1-(level-index)*2,sizeof(temp2));

//printf("offset, %d, temp2 %d\n",offset, temp2);

     // from begin to end is a list of following
     //<id@pos@pos..><id@pos@pos..>..
     
     char * begin = record+offset;
     char * end   = begin + temp2;
    
     for (char *st=begin; st<end;){
         // find the id list
         if ((st[0]=='<')&&(st[1+sizeof(id)]=='@')&&
	     (memcmp(st+1,&id,sizeof(id))==0)){
                st += (2+sizeof(id));
		
		Location *loc;

		char * pos 	= new char [20];
		int loc_level  	= 0;
		int gap   	= 0;
                while(1){
	       		while ((st[0]!='>')&&(st[0]!='@')) {
		   		pos[loc_level] = st[0];
		   		loc_level++;
		   		st++;
		   		gap++;
		   		if (st[0]=='$'){
		      			st++; gap++;
		  		}   
			}

			if (gap==0) loc = new Location();
			else loc = new Location(pos,loc_level);
//loc->dump();                       
		        // get the content from the location and compare
		        char * content = getString(record,loc,level,rec_size);	
//if (content!=NULL)printf("the string we get is %s\n",content);
//else printf("no string find\n");

			delete loc;

			if (strcmp(content,eContent)==0){
			   delete [] pos;
			   return true;
			}

			if (st[0]=='>'){
			    delete [] pos;
			    return false;
			}

			// go to next location string.
			st ++;
			loc_level =0; gap=0;

		}
	 }else st++;    
     }
     return false;
}			    
void RecordStore::loadValue(char *  record, int rec_size,
                            char *  path[], int loc_level,
                            char **& result, int & count){
      
      // skip the last two fid and eid
      rec_size -= 8;
      
      // initialized it.
      result 	= new (char *) [1024];
      for (int i=0;i<1024;i++) result[i] =NULL;
      count  	= 0;
      
      
      unsigned short level;
      memcpy(&level, record+rec_size-sizeof(level), sizeof(level));
      
      int current_level = 0;
      unsigned short id;
      
      LocationList * locationList =NULL;
      LocationList * currentList  =NULL;
      while(current_level<=loc_level){
           
	   bool avail 	= idTable->getID(path[current_level],id);
	   if (!avail) {
	       delete [] result;
	       return;
	   }

	   currentList = getLocationList(locationList,current_level, 
	                                 record,level,rec_size, id);

	   delete locationList;
	   locationList = currentList;

	   if (currentList==NULL) {
	        delete currentList;
		delete [] result;
	        return;
	   }

	   current_level ++;
      }

      currentList->initCurrent();
      Location * loc;
      while((loc = currentList->getNext())!=NULL){
           char * st = getString(record,loc,level,rec_size);
	   if (st!=NULL){ 
	      result[count] = new char [strlen(st)+1];
	      strcpy(result[count],st);
	      count++;
	   }   
      }
      
      if (count==0) delete [] result;

      delete currentList;

      return;	   
}			    

////////////////////////////////////////////////////////////////////////
// private function
////////////////////////////////////////////////////////////////////////

/* get a new LocationList from previous one. 
   new LocationList contents such locations which is one level more than
   previous one. 
   
   return : new LocationList
   input  : old LocationList --> locationList.
            currentLevel of old Location --> current_level;
	    elementName of this level    --> id
	    record --> record, level, rec_size
*/	    
LocationList * RecordStore::getLocationList(LocationList *locationList, 
           int current_level, char * record, unsigned short level, 
	   unsigned short rec_size, unsigned short id){
       
     int index 	= (id % idBucket) % level;
     
     int offset =0;
     
     LocationList * newList = new LocationList();

     // find location List from one ID.
     unsigned short temp1, temp2;
     memcpy(&temp1, record+rec_size-6,sizeof(temp1));
     for (int i=0;i<index;i++){
         memcpy(&temp2,record+temp1-(level-i)*2,sizeof(temp2));
	 offset += temp2;
     }
     memcpy(&temp2,record+temp1-(level-index)*2,sizeof(temp2));
     
     // from begin to end is a list of following
     //<id@pos@pos..><id@pos@pos..>..
     
     char * begin = record+offset;
     char * end   = begin + temp2;

     for (char *st=begin;st<end;){
         // if id is the same
	 if ((st[0]=='<')&&(st[1+sizeof(id)]=='@')&&
	     (memcmp(st+1,&id,sizeof(id))==0)){
	     st += (2+sizeof(id));
	     int stringSize;
	     if (current_level ==0) stringSize =0; 
	     else stringSize = current_level*(1+sizeof(char))-1;


	     while(1){
	         if ((st[stringSize]=='@')||(st[stringSize]=='>')){
                     
		     //create loc,copy position information from record.
		     Location *loc;
		     if (current_level!=0){
		         char *pos = new char [level];
		         for (int i=0;i<current_level;i++)
		             memcpy((char *)(&(pos[i])),
			            st+i*(1+sizeof(char)), sizeof(char));
 
         		 loc = new Location(pos,current_level);
			 delete [] pos; 
                     }else loc = new Location();

		     if ((current_level!=0)&&(checkValid(loc,locationList))){
		        newList->insertLocation(loc);
			delete loc;
//loc->dump();	             
		     }		
	             else if (current_level==0){
		        newList->insertLocation(loc);	
	                delete loc;
		     }		
	             
		     if (st[stringSize]=='>') return newList;
		     st+=(stringSize+1);
	         }
		 else{
		    while((st[0]!='@')&&(st[0]!='>')) st++;
		    if (st[0]=='>') break;
		    st++;
	         }
	     }	 
	 }
	 else st++;
     }
     
     delete newList;
//printf("null returned\n");     
     return NULL;
     
}

/* get the content of one location.
   return : content of location.
   input  : record string -->record, rec_size,level
            Location      -->loc */
char *RecordStore::getString(char * record, Location * loc, 
                             unsigned short level, int rec_size){

      int loc_sum  = (loc->getLocationSum()%locBucket)%level;
      int size;
      char * string = loc->toStoreString(size);

      unsigned short offset =0;
      unsigned short temp;
      int counter =level-1;
      while (counter>loc_sum){
         
         memcpy((char *)(&temp), record+rec_size-6-(level-counter)*sizeof(temp),
	        sizeof(temp));
         offset += temp;
	 counter--;
      }
      
      unsigned short length;
      memcpy((char *)(&length),record+rec_size-6-(level-loc_sum)*sizeof(length),
	        sizeof(length));

      char * end = record+rec_size-6-level*sizeof(unsigned short)-offset;
      char * begin = end-length;

      for (char * st=begin ;st<end;){
         if ((st[0]=='<')&&(memcmp(st+1,string,size)==0)){
	     if (st[1+size+1+sizeof(unsigned short)+1]!='>'){ 
	        delete [] string;
		return (char *)(st+1+size+1+sizeof(unsigned short));
	     }	
             else {
	         delete [] string;
		 return NULL;
	     }	 
	 }
	 else st++;
      }
      
      delete [] string;
      
      return NULL;
}

/* check if one location is a children of locationList */
bool RecordStore::checkValid(Location *loc, LocationList *locationList){
      
      locationList->initCurrent();

      Location * father;
      while(1){
          father = locationList->getNext();
	  if (father==NULL) {
	     return false;
	  }else if (loc->isChildrenOf(father)){
	     return true;
	  }   
      }
}

