#include <stdio.h>

#include "Location.h"

Location::Location(){
   location = NULL;
   level =0;
}

Location::Location(char loc){
   
   level =1;
   location = new char [level];
   location[0] = loc;

}

Location::Location(char * loc_list, int s_level){
   
   level = s_level; 
   location = new char [level];
   memcpy(location, loc_list, sizeof(char)*level);
}

Location::Location(Location * loc){
   
   level = loc->level;
   location = new char [level];
   memcpy(location, loc->location, sizeof(char)*level);
}


Location::~Location(){
   delete [] location;
}

Location Location::getFatherLocation(){
    
    if (level==1) { 
       Location loc=Location(); 
       return loc;
    }  
    else { 
       Location loc = Location(location, level-1);
       return loc;
    }   
}

Location Location::getChildrenLocation(char child_position){
     
     char *child_location = new char [level+1];
     child_location[level]= child_position;
     memcpy(child_location, location, sizeof(char)*level);
     
     Location loc = Location (child_location, level+1);
     return loc;
}

Location Location::getNextBrotherLocation(){
     char * brother_location = new char [level];
     
     brother_location[level-1]= location[level-1]+1;
     memcpy(brother_location, location, sizeof(char)*(level-1));
     
     Location loc = Location (brother_location, level);
     return loc;

}

bool Location::isFirstChild(){
    if ((level>=1)&&(location[level-1]==1)) return true;
    else return false;
}

bool Location::isRoot(){
    if (level==0) return true;
    else return false;
}

int Location::getLevel(){
    return level;
}

bool Location::sameLocation(Location *loc){
    if ((loc->level==level)&&
        (memcmp(loc->location,location,sizeof(char)*level)==0))
      return true;
    else return false;   
}

bool Location::isFatherOf(Location *loc){
    if ((loc->level==level+1)&&
        (memcmp(loc->location,location,sizeof(char)*(level-1))==0))
      return true;
    else return false;   

}

bool Location::isChildrenOf(Location *loc){
   if ((loc->level==0)&&(level==1)&&(location[0]!=0)) return true;
   else if ((loc->level==level-1)&&
        (memcmp(loc->location,location,sizeof(char)*level)==0))
      return true;
   else return false;   
}

bool Location::isBrotherOf(Location *loc){
   
   if ((loc->level==level)&&
        (memcmp(loc->location,location,sizeof(char)*(level-1))==0))
      return true;
   else return false;   
}

void Location::increaseLevel(){

    char * temp = new char [level+1];
    memcpy(temp, location, sizeof(char)*level);
    temp[level] = 1;
    level ++;
    delete [] location;
    location = temp;
}

Location * Location::createAttributeLocation(char pos){
    
    char * temp = new char [level+2];
    memcpy(((char *)temp)+sizeof(char), location, sizeof(char)*level);
    temp[0]=0;
    temp[level+1] =pos;
    
    Location * loc =  new Location(temp,level+2);
    
    delete [] temp;
    return loc;
}
void Location::decreaseLevel(){
    level --;
}

void Location::growInSameLevel(){
    location[level-1]++;
}

void Location::decreaseInSameLevel(){
    if (location[level-1]>1) location[level-1]--;
}

char* Location::toStoreString(int & strlen){
   
   if (level==0) {
        strlen =0;
	return NULL;
   }
   
   char * string = new char [level*(1+sizeof(char))];
   for (int i=0;i<level;i++){
	memcpy(string+i*(1+sizeof(char)),
	       (char *)(&(location[i])),sizeof(char));
	if (i==level-1) string[i*(1+sizeof(char))+sizeof(char)]='\0';
	else string[i*(1+sizeof(char))+sizeof(char)]='$'; 
   } 

   strlen = level*(1+sizeof(char))-1;
   return string;
}

void Location::toStoreString(char *string,int& strlen){
   
   if (level ==0){
       string =NULL;
       strlen =0;
       return;
   }
   int i; 
   strlen = level*(1+sizeof(char))-1;  
   memcpy(string, toStoreString(i), strlen);
   
}

void Location::copyLocation(Location *loc){

    level = loc ->level;
    if (location!=NULL) delete [] location;
    location = new char [level];
    memcpy((char *)location, (char *)(loc->location), 
            sizeof(char)*level);

}

void Location::dump(){
   
   printf("dump location: ");
   for (int i=0;i<level;i++)
      printf("%d ",location[i]);
   printf("\n");   
}

void Location::getLocationNumber(char * loc, int & slevel){
   
   slevel = level;
   memcpy(loc, location, sizeof(char)*level);
   
}

int Location::getLocationSum(){

    int sum =0;
    for (int i=0;i<level;i++) sum+= location[i];

    return sum;
}
/*main(){

   Location loc0 = Location();
   Location loc1 = Location(0);
   Location loc2 = Location(1);
   Location loc3 = loc2.getNextBrotherLocation();
   loc0.dump();
   loc1.dump();
   loc2.dump();
   loc3.dump();

   Location loc4 = Location(2);
   if(loc4.sameLocation(&loc3)) 
     printf("same\n");
   else printf("inequal\n");

}*/
