#ifndef _PAGESTORE_H_
#define _PAGESTORE_H_

#include <sys/time.h>

class PageStore {
   private:
     static int count;
     static int pagesize;  
     static int slotSize; 
     static int reserveSize;

     static long opentime;
     static long closetime;
     static long readtime;
     static long writetime;
     
     struct timeval tval1;
     struct timeval tval;

   private:
     char* mem;
     short recordCounter;
     short emptySpace;
     
   public:
      PageStore(char * mem_page = NULL);

     ~PageStore();
     
     static void initTime();
     static void showTime();

     int getPageSize();
     int getPageCounter();

     void createNewPage();
     bool insertRecord(char *record, unsigned short rec_size, unsigned short &);
     bool writeToDisk(char *filename);
     
     bool getRecord(char * &record, unsigned short &rec_size, 
          unsigned short rec_id);
     bool loadFromDisk(char *filename);
     bool copyRecord(char * &record, unsigned short &rec_size, 
          unsigned short rec_id);
    
     void dumpPage();
     
     long getDiff();
     
};

#endif

