/**
 * Util.C
 * Author: Yuan Wang
 * Implementation of file name vector
 */

#include <iostream.h>

#include "Util.h"


/**
 * Constructor.
 */
FileNameVector::FileNameVector ()
{
  this->firstIndex = 0;
  this->secondIndex = 0;

  this->names = new char**[100];
  this->names[0] = new char*[FIRST_SIZE];
}


/**
 * Destructor.
 */
FileNameVector::~FileNameVector ()
{
  for ( int i = 0; i <= this->secondIndex; i++ )
    {
      for ( int j = 0; j < this->firstIndex; j++ )
	delete this->names[i][j];

      delete this->names[i];
    }

  delete this->names;
}


/**
 * Add a file name.
 * @param fileName  file name
 * @return file id
 */
int FileNameVector::addFileName ( char* fileName )
{
  this->names[secondIndex][firstIndex] = fileName;

  int fid = secondIndex * FIRST_SIZE + firstIndex;

  if ( firstIndex < FIRST_SIZE )
    firstIndex++;
  else if ( secondIndex < SECOND_SIZE )
    {
      secondIndex++;
      this->names[secondIndex] = new char*[FIRST_SIZE];
      firstIndex = 0;
    }
  else
    {
      cout << "File name capacity crash!" << endl;
      exit( -1 );
    }

  return fid;
}


/**
 * Get the file name by its id.
 * @param fid  file id
 * @return file name
 */
char* FileNameVector::getFileName ( int fid )
{
  int second = fid / FIRST_SIZE;
  if ( second > this->secondIndex )
    return NULL;

  int first = fid % FIRST_SIZE;
  if ( ( second == this->secondIndex ) && ( first >= this->firstIndex ) )
    return NULL;

  return this->names[second][first];
}
