#ifndef __NODE__
#define __NODE__

#include "constant.h"

class Node {

	public:
		Node(char tag, char key_type, int key_len, int other_field_len, char* prefix);
		~Node();

		int addToLeaf(char*, char*);
		int addToOther(char*, int);
		int addToOther(int);	
		int addToEntry(char*);

		char* getFileName();
		void outToFile();
		Node* getFather();
		void reset();
		void setFather(Node*);
		int getFileNum();
		int getOffset();
		void setFileNumZero(); 

		void dump();


	private:

		char* data;
		char* filename_prefix;
		char key_type;

		char leafTag;
		int key_len;
		int other_field_len;

		int max_space;
		int used_space;

		int next;
		int first;

		Node* father;

		int file_num;

		int static file_num_count;
};

#endif
