#include "query.h"
#include "predit.h"
#include "constant.h"
#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <strstream.h>

Query::Query(char* buf, int& tag) {
	buffer=buf;
	int i=strlen(buf)-1;
	if(buffer[i]=='\n') {
		i--;
		while(buffer[i]==' ') i--;
	}
	buffer=new char[i+2];
	memcpy(buffer, buf, i+1);
	buffer[i+1]='\0';
	tag=parse();
}

Query::~Query() {
	delete [] buffer;
}

void Query::Error(int No) {
	switch(No) {
		case 1:
			cout<<"Unknown command!"<<endl;
			break;
		default:
			cout<<"Error occurs!!"<<endl;
			break;
	}
}

int Query::parse() {
	istrstream str(buffer, strlen(buffer));
	char temp[256];
	char* fieldName;
	char* sValue;
	int iValue;
	char tag;
	Predit* pp;
	int op;
	int i=0;

	char c;

	str>>temp;
	if(strcmp(temp, "cd")!=0&&strcmp(temp, "ls")!=0) {
		Error(1);
		return 1;
	}
	do {
		str.get(c);
	} while(c==' ');
	str.putback(c);
	tag=0;

	while(!str.eof()){
		str.get(c);
		while(c!='='&&c!='>'&&c!='<') {
			temp[i]=c;
			i++;
			str.get(c);
		}
		temp[i]='\0';
		fieldName=new char[strlen(temp)+1];
		strcpy(fieldName, temp);
		if(c=='=') op=EQ_OP;
		else if(c=='>') {
			str.get(c);
			if(c=='=') op=GE_OP;
			else {
				str.putback(c);
				op=GT_OP;
			}
		}
		else if(c=='<') {
			str.get(c);
			if(c=='=') op=LE_OP;
			else {
				str.putback(c);
				op=LT_OP;
			}
		} 
		else {
			Error(0);
			return 1;
		}
		do {
			str.get(c);
		} while(c==' ');
		if(c=='"') {
			// did not consider that the string contain "
			str.get(temp, 256, '"');
			sValue=new char[strlen(temp)+1];
			strcpy(sValue, temp);
			str.get(c);
			if(tag==0) {
				predit=new Predit(fieldName, sValue, op);
				pp=predit;
			}
			else {
				pp->next=new Predit(fieldName, sValue, op);
				pp=pp->next;
			}
		}
		else {
			str.putback(c);
			str>>iValue;
			if(tag==0) {
				predit=new Predit(fieldName, iValue, op);
				pp=predit;
			}
			else {
				pp->next=new Predit(fieldName, iValue, op);
				pp=pp->next;
			}
		}
		do {
			str.get(c);
		} while(c==' '&&(!str.eof()));
		if(str.eof()) return 0;
		else if(c=='|') {
			str.get(c);
			if(c!='|') {
				Error(0);
				return 1;
			}
			pp->nextType='\0';
			tag=1;
		}
		else if(c=='&') {
			str.get(c);
			if(c!='&') {
				Error(0);
				return 1;
			}
			pp->nextType='\1';
			tag=2;
		}
		else {
			Error(0);
			return 1;
		}
		do {
			str.get(c);
		} while(c==' '&&(!str.eof()));
		str.putback(c);
	}
	return 0;
}

Predit* Query::getPredit() {
	return predit;
}

char* Query::getBuffer() {
	return buffer;
}

/*
main() {
	Query *q=new Query("cd tt=\"abc\" && yy=3");
	q->parse();
	delete q;
}
*/
