#include "constant.h"
#include "runfile.h"
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>

long RunFile::openTime;
long RunFile::closeTime;
long RunFile::writeTime;
long RunFile::readTime;

RunFile::RunFile(char* filename, char mode) {

	this->mode=mode;
	fname=new char[strlen(filename)+1];
	strcpy(fname, filename);
	if(mode==READONLY) {
		gettimeofday(&tval, 0);
		ff=fopen(filename, "r");
		gettimeofday(&tval1, 0);
	}
	else if(mode==CREATENEW) {
		gettimeofday(&tval, 0);
		ff=fopen(filename, "w");
		gettimeofday(&tval1, 0);
	}
	RunFile::openTime+=getDiff();
	exist=true;
}

RunFile::RunFile(char* filename, char mode, char& tag) {

	this->mode=mode;
	fname=new char[strlen(filename)+1];
	strcpy(fname, filename);
	if(mode==READONLY) {
		gettimeofday(&tval, 0);
		ff=fopen(filename, "r");
		gettimeofday(&tval1, 0);
	}
	else if(mode==CREATENEW) {
		gettimeofday(&tval, 0);
		ff=fopen(filename, "w");
		gettimeofday(&tval1, 0);
	}
	RunFile::openTime+=getDiff();
	if(ff==NULL) tag=0;
	else tag=1;
	exist=true;
}

RunFile::~RunFile() {
	delete [] fname;
	if(exist) {
		gettimeofday(&tval, 0);
		fclose(ff);
		gettimeofday(&tval1, 0);
		RunFile::closeTime+=getDiff();
	}
}

int RunFile::getFileLen(char* name) {
	struct stat buf;
	stat(name, &buf);
	return buf.st_size;
}

void RunFile::insertRecord(char* buffer, int length) {
	gettimeofday(&tval, 0);
	fwrite(buffer, 1, length, ff);
	gettimeofday(&tval1, 0);
	RunFile::writeTime+=getDiff();
}

// delete the file
void RunFile::deleteFile() {

	exist=false;
	gettimeofday(&tval, 0);
	fclose(ff);
	gettimeofday(&tval1, 0);
	RunFile::closeTime+=getDiff();
	unlink(fname);
}

int RunFile::getRecord(char* buffer, int length) {
	int temp;
	gettimeofday(&tval, 0);
	temp=fread(buffer, 1, length, ff);
	gettimeofday(&tval1, 0);
	RunFile::readTime+=getDiff();
	return temp;
}

long RunFile::getDiff() {
	long temp;

	temp=(tval1.tv_sec-tval.tv_sec)*1000000;
	temp+=(tval1.tv_usec-tval.tv_usec);
	return temp;
}
