
#include <stdio.h>
#include <stdlib.h>

#include "RecordStore.h"
#include "FileStore.h"

#include "constant.h"

#define YINGDEBUG  true

int repeat =0; 

// this function is used to check if an elmement <eName> has the value
// eContent in record <fid,rid>
bool scanCheck(RecordStore * recordStore, FileStore * fileStore,
          int fid, unsigned short rid, char *eName, char * eContent){

    char *record;
    unsigned short length;
    
    fileStore->getRecord(record,length,fid,rid);
    if (recordStore->scanCheck(record, length, eName, eContent)){
         delete [] record;
	 return true;
    };

    delete [] record;
    return false;
}

int beginScan(RecordStore *recordStore, FileStore * fileStore,
              char * eName, char * eContent, int& fid, unsigned short& rid, 
	      int& yuanFid, unsigned short& yuanRid ){
    
    char *record;
    unsigned short length;

    if (fileStore->beginScan(record,length,fid, rid)<0) {
       return -1; // no record;
    }

//if (YINGDEBUG) if (repeat==1){ getchar(); delete [] record; return -1;}

    if (recordStore->scanCheck(record,length,eName,eContent)){
       
       int temp;
       yuanFid = recordStore->getFid(record, length);
       temp    = recordStore->getEid(record, length);
       yuanRid = (short)temp;
if(YINGDEBUG) {
//printf("in scan: yuan %d %d ,ying %d %d\n",yuanFid, yuanRid, fid, rid);
}
       
       delete [] record;
       return 1;
    }
    else {
if(YINGDEBUG) {
int temp;
       yuanFid = recordStore->getFid(record, length);
       temp    = recordStore->getEid(record, length);
       yuanRid = (short)temp;

//printf("in scan: yuan %d %d ,ying %d %d\n",yuanFid, yuanRid, fid, rid);
}    
       delete [] record;
       return 0;
    }
    
}	      
              
int getNext(RecordStore * recordStore, FileStore * fileStore,
            char * eName,  char *eContent,
	    int& fid, unsigned short& rid, 
	    int& yuanFid, unsigned short& yuanRid 
	    ){
   
    char * record;
    unsigned short length;
/*if (YINGDEBUG){
   if (repeat ==1) return -1;
}*/

    if (fileStore->getNext(record, length,fid, rid)<0) {
if (YINGDEBUG) repeat =1;    
       return -1;
    }
    if (recordStore->scanCheck(record, length, eName,eContent)) {
       
       int temp;
       yuanFid = recordStore->getFid(record, length);
       temp    = recordStore->getEid(record, length);
       yuanRid = (short)temp;

if(YINGDEBUG) {
//printf("in scan: yuan %d %d ,ying %d %d \n",yuanFid, yuanRid, fid, rid);
}
       delete [] record;
       
       return 1;
    }else {
if(YINGDEBUG) {
int temp;
       yuanFid = recordStore->getFid(record, length);
       temp    = recordStore->getEid(record, length);
       yuanRid = (short)temp;

//printf("in scan: yuan %d %d ,ying %d %d\n",yuanFid, yuanRid, fid, rid);
}      
       delete [] record;
       return 0;
    }
	    



}
